defApplication('modprobe', 'modprobe') {|a|
   a.name = "modprobe" 
   a.version(0, 0, 1)
   a.path = "/sbin/modprobe" 
   a.defProperty('args', "Arguments for modprobe command", nil,  {:order => 1, :dynamic => false, :type => :string, :use_name => false})
}

defApplication('wimaxd', 'wimaxd') {|a|
   a.name = "wimaxd" 
   a.version(0, 0, 1)
   a.path = "/usr/bin/wimaxd" 
   a.defProperty('args', "Arguments for wimaxd command", nil,  {:order => 1, :dynamic => false, :type => :string, :use_name => false})
}

defApplication('wimaxcu', 'wimaxcu') {|a|
   a.name = "wimaxcu" 
   a.version(1, 5, 1)
   a.path = "/usr/bin/wimaxcu" 
   a.defProperty('args', "Arguments for wimaxcu command", nil,  {:order => 1, :dynamic => false, :type => :string, :use_name => false})
}

defApplication('ifconfig', 'ifconfig') {|a|
   a.name = "ifconfig" 
   a.version(0, 0, 1)
   a.path = "/sbin/ifconfig" 
   a.defProperty('args', "Arguments for ifconfig command", nil,  {:order => 1, :dynamic => false, :type => :string, :use_name => false})
}

defApplication('oml2-iperf', 'oml2-iperf') {|a|
   a.name = "oml2-iperf" 
   a.version(0, 0, 1)
   a.path = "/usr/local/bin/oml2-iperf" 
   a.defProperty('args', "Arguments for ifconfig command", nil,  {:order => 1, :dynamic => false, :type => :string, :use_name => false})
}


defGroup('ServerRun', [1,4]) { |node|


  #node.net.x0.profile = '51'
  #node.exec('wimaxcu', ['connect network 51'])


  node.exec('ifconfig', ['wmx0 10.41.14.4 netmask 255.255.0.0 up'])

  node.addApplication("oml2-iperf") { |app|
    app.setProperty('args','-s -B 10.41.14.4 -w 256k')
  }
}

defGroup('ClientRun', [1,9]) { |n|
  n.exec('ifconfig', ['eth0 10.41.4.9 netmask 255.255.0.0 up'])

  #n.exec('oml2-iperf', ['-y o --oml-id 3 --oml-exp-id exp3 --oml-server oml:3003 -c 10.41.14.4 -i 1'])
  n.addApplication("oml2-iperf") { |app|
    app.setProperty('args','-y o --oml-id 3 --oml-exp-id exp4 --oml-server oml:3003 -c 10.41.14.4 -i 1 -t 10')
  }
}


whenAllInstalled() {|node|
  info "Give machines some time to warm up" 
  wait 10

   #info "--Setting modulation scheme"
   #system("wget -O status_dl http://cons-wm-01:5052/wimaxrf/mcsProfile?dl=17")
   #system("wget -O status_ul http://cons-wm-01:5052/wimaxrf/mcsProfile?ul=13")
   #wait 1
   #system("wget -O status http://cons-wm-01:5052/wimaxrf/restart")
   #wait 30
   #wait 30


  info "Connect to base station" 
  system("ssh root@node1-4 'wimaxcu ron ; wimaxcu connect network 51'")
  wait 5

  info "Setting attenuator level"
  AttenuatorVector = [0, 5, 10, 15, 20]
  AttenuatorVector.each do |attenDb|
    system("wget -O status http://internal2dmz.orbit-lab.org:5052/instr/set?portA=4\\&portB=9\\&att=#{attenDb}")
    wait 1

    system ("ssh root@node1-4 'wimaxcu status link' > wimaxcu_status")
    freq = ` cat wimaxcu_status | grep Frequency | awk \'{print$3}\' `
    rssi = ` cat wimaxcu_status | grep RSSI      | awk \'{print$3}\' `
    cinr = ` cat wimaxcu_status | grep CINR      | awk \'{print$3}\' `
    txpw = ` cat wimaxcu_status | grep "TX PWR"  | awk \'{print$4}\' `
    bsid = ` cat wimaxcu_status | grep "BS ID"   | awk \'{print$4}\' `

    puts "freq: #{freq}"
    puts "rssi: #{rssi}"
    puts "cinr: #{cinr}"
    puts "txpw: #{txpw}"
    puts "bsid: #{bsid}"

    info "Start iperf server"
    group("ServerRun").startApplications
    wait 3
    info "Start iperf client"
    group("ClientRun").startApplications
    
    info "Collect measurements for 10 seconds" 
    wait 10
    
    info "Stop applications"
    allGroups.stopApplications
    wait 5

    size = ` sqlite3 /var/lib/oml2/exp4.sq3 \"select * from iperf_transfer\" | tail -1 | awk -F\\| \'{print $9}\' `
    time = ` sqlite3 /var/lib/oml2/exp4.sq3 \"select * from iperf_transfer\" | tail -1 | awk -F\\| \'{print $8}\' `
    puts "Size: #{size}"
    puts "Time: #{time}"
    kBperS = 8.0 * size.to_f / time.to_f / 1024.0
    puts "b: #{kBperS}"

    wait 1
    system(" sqlite3 values.db \"create table t1 (t1key INTEGER PRIMARY KEY, atten INTEGER, nBytes INTEGER, time INTEGER, kBperS FLOAT, freqkhz INTEGER, rssi_dbm INTEGER, cinr_db INTEGER, txpw_dbm INTEGER);\" ")
    system(" sqlite3 values.db \"insert into t1 (atten,nBytes,time,kBperS,freqkhz,rssi_dbm,cinr_db,txpw_dbm) values (#{attenDb}, #{size}, #{time}, #{kBperS},#{freq},#{rssi},#{cinr},#{txpw});\" ")
    
  end

  info "Reset attenuator back to zero"
  system("wget -O status http://internal2dmz.orbit-lab.org:5052/instr/set?portA=4\\&portB=9\\&att=0")

  # Turn off wimax radio gracefully
  system("ssh root@node1-4 'wimaxcu dconnect ; wimaxcu roff'")

  #system("cp /var/lib/oml2/exp4.sq3 .")

  info "Finish it." 
  Experiment.done
}




